NEW
100 REM ############# TYPE.BAS
101 REM DESC:TYPE A TEXTFILE
117 REM DATE:10.11.2024
118 REM ######################
119 :
200 REM ********** DEFINITIONS
201 REM ======== CONTROL CHARS
202 LET CD$ = CHR$(4)
204 LET CR$ = CHR$(13)
206 REM ==== DOS/PRODOS SELECT
208 GOSUB 9820 :REM PD()
209 :
300 REM ***************** MAIN
302 REM ============== SIGN ON
304 PRINT
306 PRINT PD$; " TYPE V1.0"
308 PRINT
309 :
400 REM ========= GET FILENAME
402 GOSUB 8820 :REM FA()
404 IF BK% = 1 THEN 996
405 :
500 REM ======== TYPE THE FILE
502 HOME
504 PRINT "TYPING "; FA$
506 IF PD% = 0 THEN 552
507 :
510 REM - PRODOS REQUIRES OPEN
511 REM OPEN CREATES THE FILE
512 REM IF IT DOES NOT EXIST.
513 REM WE DO A CAT <FILE>. IT
514 REM TRHOWS ERR 13, TYPE
515 REM MISMATCH, IF FILE
516 REM EXISTS. A ERR 6 MEANS
617 REM FILE DOES NOT EXIST.
518 REM ----------------------
520 ONERR GOTO 526
522 PRINT CD$; "CAT "; FA$
523 :
524 REM ---- CAT ERROR HANDLER
526 LET CR% = PEEK(222)
528 POKE 222,0 :REM CLR ERR
530 POKE 216,0 :REM ERR FLAG
532 IF CR% = 13 THEN 542
534 POKE 222,6
536 GOTO 9920 :REM EH()
537 :
540 REM ------------ OPEN FILE
542 ONERR GOTO 9920
544 PRINT CD$; "OPEN "; FA$
545 :
550 REM -------- READ AND SHOW
552 ONERR GOTO 9920
554 PRINT CD$; "READ "; FA$
555 :
560 GET CH$
562 PRINT CH$;
564 GOTO 560
565 :
990 REM ================= EXIT
992 PRINT CR$;
994 PRINT CD$; "CLOSE "; FA$
996 PRINT
997 END
998 REM ######### EOF TYPE.BAS
999 :
8000 REM ############# LIBRARY
8600 REM ================ KS()
8601 REM DESC:INPUT STRING
8602 REM IN..:KS%= MAX LEN
8603 REM OUT.:KS$= IN STRING
8604 REM      BK%= 1 IF CR P1
8619 REM =====================
8620 LET BK% = 0
8622 LET KS$ = ""
8624 LET BS$ = CHR$(8)
8626 LET CR$ = CHR$(13)
8627 :
8640 REM ---- READ A CHARACTER
8642 GET SG$
8644 IF SG$ = CR$ THEN 8742
8646 IF SG$ = BS$ THEN 8702
8648 LET SG% = ASC(SG$)
8650 IF SG% < 32 THEN 8642
8651 :
8660 REM --------- REGULAR KEY
8662 PRINT SG$;
8664 LET SL$ = SG$
8666 IF KS% = 1 THEN KS$ = ""
8668 LET KS$ = KS$ + SG$
8670 LET SL% = LEN(KS$)
8672 IF SL% < KS% THEN 8642
8673 :
8680 REM ---- ON LAST POSITION
8682 PRINT BS$;
8684 IF SL% <= KS% THEN 8642
8686 LET S% = SL% - 2
8688 IF S% = 0 THEN S% = 1
8690 LET KS$ = LEFT$(KS$,S%)
8692 LET KS$ = KS$ + SG$
8694 GOTO 8642
8695 :
8700 REM ----------- BACKSPACE
8702 LET SL% = LEN(KS$)
8704 IF SL% = 0 THEN 8642
8706 IF KS% = 1 THEN 8710
8708 IF SL% > 1 THEN 8714
8710 LET KS$ = ""
8712 GOTO 8720
8714 LET S% = SL% - 1
8716 LET KS$ = LEFT$(KS$,S%)
8718 IF SL% = KS% THEN 8724
8720 IF KS% = 1 THEN 8724
8722 PRINT BS$;
8724 PRINT " " + BS$;
8726 GOTO 8642
8727 :
8740 REM ------------------ CR
8742 LET SL% = LEN(KS$)
8744 LET BK% = (SL% = 0)
8746 IF BK% = 1 THEN KS$ = ""
8745 :
8748 REM -- MOVE CURSOR TO END
8750 IF SL% < KS% THEN 8756
8752 PRINT SL$;
8754 GOTO 8797
8755 :
8756 PRINT SPC(KS% - SL%);
8757 :
8797 RETURN
8798 REM ============ EOS KS()
8799 :
8800 REM ================ FA()
8801 REM DESC:ENTER FILENAME,
8802 REM      OPTIONALLY SHOW
8803 REM      DIRECTORY
8804 REM OUT.:FA$:PATH/FILE
8805 REM      BK%:1=ABORTED
8806 REM CALL:PD(), 9820
8807 REM      KS(), 8720
8818 REM =====================
8820 LET BK% = 1
8822 LET CD$ = CHR$(4)
8824 LET BS$ = CHR$(8)
8826 LET CR$ = CHR$(13)
8827 :
8828 GOSUB 9820 : REM PD()
8829 :
8830 REM --- DOS/PRODOS SELECT
8832 LET SC$ = "CAT"
8834 IF PD% = 1 THEN 8842
8836 LET SC$ = "CATALOG"
8839 :
8840 REM ----- FUNCTION SELECT
8842 PRINT "C)AT F)ILENAME ";
8844 GET SF$
8846 IF SF$ = CR$ THEN 8897
8848 IF SF$ = "C" THEN 8862
8850 IF SF$ = "F" THEN 8872
8852 GOTO 8844
8853 :
8860 REM ------ SHOW DIRECTORY
8862 PRINT
8864 PRINT CD$; SC$
8866 PRINT
8868 GOTO 8842
8869 :
8870 REM ------ ENTER FILENAME
8872 FOR S = 1 TO 15
8874 :PRINT BS$;
8876 NEXT S
8877 :
8878 PRINT "FILENAME:     ";
8880 PRINT BS$;BS$;BS$;BS$;
8882 LET KS% = 30
8884 GOSUB 8720 :REM KS()
8886 LET FA$ = KS$
8887 :
8897 RETURN
8898 REM ============ EOS FA()
8899 :
9800 REM ================ PD()
9801 REM DESC:CHECK IF PRODOS
9802 REM      IS RUNNING. AT
9803 REM      $BEE0 THERE IS
9804 REM      'COPYRIGHT...'
9805 REM      CHECKS 4 BYTES.
9806 REM OUT.:PD%: 1=PRODOS
9807 REM      PD$: DOS/PRODOS
9818 REM =====================
9820 LET PD% = 0
9822 LET PD$ = "DOS"
9824 LET SA = 48864
9826 LET S%(0) = 195 :REM 'C'
9828 LET S%(1) = 207 :REM 'O'
9830 LET S%(2) = 208 :REM 'P'
9832 LET S%(3) = 217 :REM 'Y'
9833 :
9834 FOR S = 0 TO 3
9836 :LET S1% = PEEK(SA + S)
9838 :LET S2% = S%(S)
9840 :IF S1% <> S2% THEN 9897
9842 NEXT S
9843 :
9844 LET PD% = 1
9846 LET PD$ = "PRODOS"
9847 :
9897 RETURN
9898 REM ============ EOS PD()
9899 :
9900 REM ================ EH()
9901 REM DESC:DOS ERR HANDLER
9902 REM      RESUMES AFTER
9903 REM      LINE CAUSING THE
9904 REM      ERROR
9905 REM      CALLED BY ONERR
9906 REM OUT.:EH%= ERROR NBR
9918 REM =====================
9920 LET SA% = 222 :REM ACTERR
9922 LET SC% = 216 :REM CLRERR
9923 :
9924 LET EH% = PEEK(SA%)
9926 POKE SC%,0
9928 POKE SA%,0
9929 :
9930 LET S$ = E1$(1)
9932 IF S$ <> "" THEN 9970
9933 :
9940 E1$(1) = "LNG NOT AVAIL"
9942 E1$(2) = "RANGE ERROR"
9944 E1$(3) = "RANGE ERROR"
9946 E1$(4) = "WRITE PROTECT"
9948 E1$(5) = "END OF DATA"
9950 E1$(6) = "FILE NOT FOUND"
9952 E1$(7) = "VOL MISMATCH"
9954 E1$(8) = "I/O ERROR"
9956 E1$(9) = "DISK FULL"
9958 E2$(1) = "FILE LOCKED"
9960 E2$(2) = "SYNTAX ERROR"
9962 E2$(3) = "NO BUFFERS"
9964 E2$(4) = "TYPE MISMATCH"
9966 E2$(6) = "PROG TOO LARGE"
9968 E2$(7) = "NOT DIRECT CMD"
9969 :
9970 IF EH% > 9 THEN 9976
9972 LET S$ = E1$(EH%)
9974 GOTO 9986
9976 IF EH% > 15 THEN 9982
9978 LET S$ = E2$(EH%-9)
9980 GOTO 9986
9982 LET S$ = "ERROR "
9984 LET S$ = S$ + STR$(EH%)
9985 :
9986 PRINT
9988 INVERSE
9990 PRINT S$;
9992 NORMAL
9993 :
900  REM ** ERR HANDLER RETURN
9996 GOTO 900
9997 REM ============ EOH EH()
9998 :
9999 REM ######### END LIBRARY
